ach_flattenmeta gem
===================

This gem provides a class to read a config hash with metadata and return only the relevant config items for your platform and environment
based on the data in your metadata.

It is to be used in chef resources, to make the attribute system more usabled and to write "data driven" resources.


- FlattenMeta class

Generic class to read a config hash metadata and return only the relevant config items for your platform and environment based on a metadata hash

Example:
```
# Firewall rich rules
default['fw_richrules']['ach_base'] = {
 'metadata': {
   'platforms' => ['rhel7'],
   'environments' => ['all'],
   'priority' => ['99'],
   'active' => true
 },
 'rule family="ipv4" source address="192.168.1.101/32" service name="https" accept limit value="1/m"': true
}
```

the keyword `all` can be used in the `platforms` and `environments` array to specify any platform/environment

A priority system is used to override values of existing config items, the lowest priority number equals the highest priority.
ach_base config items should default to prio value 99, application cookbooks should defaut to prio 50

If you want to totally disable a config key,value pair you have to define a new config hash with its `active` property in the meta hash set to false

Example:# ach_flattenmeta
Example:
```
default['ach_sysctl']['ach_base'] = {
  'metadata' => {
    'platform' => ['default'],
    'environments' => ['default'],
    'priority' =>  99,
    'active'=> true
  },
    'sunrpc.transports' => 'udp 32768',
    'vm.nr_hugepages' => 0
}

default['ach_sysctl']['ach_base_override'] = {
  'metadata' => {
    'platform' => ['default'],
    'environments' => ['default'],
    'priority' =>  99,
    'active'=> false
  },
    'vm.nr_hugepages' => 0
}
```
